// alexweather.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#define _WINSOCK_DEPRECATED_NO_WARNINGS
#include "resource.h"
#include <iostream>  
#include <thread>   
#include <winsock2.h>
#include <windows.h>
#include <string>
#include <locale>
#pragma comment(lib,"ws2_32.lib")

//define _countof(x) (sizeof(x) / sizeof((x)[0]))

void aComThreadBody(void);
std::thread aCommThread(aComThreadBody);

/***************
***Structures***
***************/
struct CWndSizeData {
	HWND m_hWnd;
	RECT m_stRect;
	int m_nResizeFlags;
};
struct CPopupWndData {
	HWND m_hWnd;
	SIZE m_stInitialSize;

	CWndSizeData* m_pControls; // currently we have 3 child controls
	DWORD m_dwControls;

	static CPopupWndData* s_pThis;
};


/**********************
*******Globals*********
***********************/
HWND hAWnd = NULL;
WCHAR pGBuf[GLOBALBUF];
const UINT WM_TRAY = WM_USER + 1;
HINSTANCE g_hInstance = NULL;
HICON g_hIcon = NULL;
HANDLE hPort = NULL;
HWND g_hCodePages = NULL;
long g_nLastCodePage = 0;
CPopupWndData* CPopupWndData::s_pThis = NULL;
BOOL bNodata = TRUE;

BOOL OpenComm(void)
{
	BOOL bRetCode = FALSE;
	DCB dcbStr;
	TCHAR tcComPortAddr[MAX128];
	TCHAR tcValue[MAX128];
	char cValue[MAX128];
	COMMTIMEOUTS comTimeOut;
	DWORD dwLen = sizeof(tcValue);
	/*****************************
	***Trying to get COM port #***
	******************************/

	if (ERROR_SUCCESS == RegGetValue(HKEY_LOCAL_MACHINE, TEXT("HARDWARE\\DEVICEMAP\\SERIALCOMM"), TEXT("\\Device\\VCP0"), RRF_RT_REG_SZ, NULL, tcValue, &dwLen))
	{
		wcstombs_s(NULL, cValue, MAX128, tcValue, MAX128);
		//printf("USB2UART port found. Attempting %s\n", cValue);
		tcComPortAddr[0] = 0;
		tcComPortAddr[1] = 0;
		wcscat_s(tcComPortAddr, MAX128, L"\\\\.\\");
		wcscat_s(tcComPortAddr, MAX128, tcValue);
		hPort = CreateFile((LPCWSTR)tcComPortAddr, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	}
	else
	{
		/************************
		****Exiting..........****
		*************************/
		bRetCode = 1;
	}

	if (!GetCommState(hPort, &dcbStr))
	{
		bRetCode = 1;
	}
	dcbStr.BaudRate = CBR_19200;
	dcbStr.ByteSize = EIGHTBIT;
	dcbStr.Parity = NOPARITY;
	dcbStr.StopBits = ONESTOPBIT;
	if (!SetCommState(hPort, &dcbStr))
	{
		bRetCode = 1;
	}

	/***************************************************
	**Specify time-out between charactor for receiving**
	***************************************************/
	comTimeOut.ReadIntervalTimeout = 3;
	
	/***************************************************
	********* Specify value that is multiplied *********
	**** by the requested number of bytes to be read****
	***************************************************/
	comTimeOut.ReadTotalTimeoutMultiplier = 3;

	/**************************************************
	** Specify value is added to the product of the ***
	** ReadTotalTimeoutMultiplier member***************
	**************************************************/
	comTimeOut.ReadTotalTimeoutConstant = 2;

	/**************************************************
	******* Specify value that is multiplied **********
	*** by the requested number of bytes to be sent. **
	**************************************************/
	comTimeOut.WriteTotalTimeoutMultiplier = 3;

	/**************************************************
	*** Specify value is added to the product of the **
	*** WriteTotalTimeoutMultiplier member ************
	**************************************************/
	comTimeOut.WriteTotalTimeoutConstant = 2;
	
	/**************************************************
	** set the time-out parameter into device control.*
	**************************************************/
	SetCommTimeouts(hPort, &comTimeOut);

	if (bRetCode)
	{
		swprintf_s(pGBuf, L"Failed to open COM port..\n");
		if (hAWnd)
		{
			HWND hEditCtrl = GetDlgItem(hAWnd, IDC_TEXT);
			SetWindowText(hEditCtrl, pGBuf);
		}
	}
	else
	{
		swprintf_s(pGBuf, L"%s opened, waiting for data..\n", tcValue);
		if (hAWnd)
		{
			HWND hEditCtrl = GetDlgItem(hAWnd, IDC_TEXT);
			SetWindowText(hEditCtrl, pGBuf);
		}
	}


	return (bRetCode);
}

void aComThreadBody(void)
{
	unsigned int uiCntr = 0;
	HWND hEditCtrl = NULL;
	
	DWORD dwBytesRead = 0;
	unsigned char ucVdata[MAX_BUF];

	time_t ttRawtime = 0;
	time_t ttCurtime = 0;
	unsigned char ucState = 0;

	double df_T = 0.0;
	double df_P = 0.0;
	double df_H = 0.0;
	int t_fine_mst;

	const unsigned char ucPattern[] = { 'a', 'l', 'x', 'l', 'a', 'b', 's', 'O' };
	unsigned int uiMatch = 0;
	unsigned int uiRCCntr = 0;
	unsigned char ucRCPat[ONELOAD];
	time_t ttTime = time(NULL);
	unsigned char ucCRC = 0;
	DWORD dwError;
	char cBuf[MAX_BUF];
	
	WSADATA wsaData;
	SOCKET Socket;
	SOCKADDR_IN SockAddr;
	struct hostent *host;
	char get_http[MAX_BUF];

	FILE *fpFile = NULL;

	pGBuf[0] = 0;
	
	while (TRUE)
	{
		if (!OpenComm())
		{
			uiMatch = 0;
			while (true)
			{
				::ReadFile(hPort, ucVdata, 1, &dwBytesRead, NULL);
				dwError = GetLastError();
				if (dwError && ERR_ALREADY != dwError)
				{
					CloseHandle(hPort);
					while (OpenComm());
				}
				if (dwBytesRead)
				{
					if (ucVdata[0] == ucPattern[uiMatch])
					{
						uiMatch++;
						if (sizeof(ucPattern) == uiMatch)
						{
							ttTime = time(NULL);
							ctime_s((char*)ucVdata, sizeof(ucVdata), &ttTime);

							for (uiRCCntr = 0; uiRCCntr < sizeof(ucVdata); uiRCCntr++)
							{
								if (CARRRET == ucVdata[uiRCCntr])
								{
									ucVdata[uiRCCntr] = 0;
								}
							}
							uiMatch = 0;
							ucCRC = 0;
							/**********************
							***Initialize buffer***
							**********************/
							for (uiRCCntr = 0; uiRCCntr < ONELOAD; uiRCCntr++)
							{
								ucRCPat[uiRCCntr] = 0;
							}
							ucState = 0;
							/************************************
							**77 + 8hex bytes from address 0x88**
							************************************/
							for (uiRCCntr = STARTADDR; uiRCCntr < ONELOAD; uiRCCntr++)
							{
								dwBytesRead = 0;
								time(&ttRawtime);
								while (!dwBytesRead)
								{
									::ReadFile(hPort, ucVdata, 1, &dwBytesRead, NULL);
									dwError = GetLastError();
									if (dwError && ERR_ALREADY != dwError)
									{
										CloseHandle(hPort);
										while (OpenComm());
									}

									time(&ttCurtime);
									if (ttCurtime - ttRawtime > RDTIMEOUT)
									{
										uiRCCntr = ONELOAD;
										dwBytesRead = EXITONE;
										ucState = ERRRECG;
									}
								}
								ucRCPat[uiRCCntr] = ucVdata[0];
								if (ONELOAD - 1 != uiRCCntr)
								{
									ucCRC += ucVdata[0];
								}
							}
							/******************
							***Calculations****
							******************/

							if (ucCRC != ucRCPat[CRCBYTE])
							{
								ucState = ERRRECG;
							}

							if (!ucState)
							{

								/**************************************************************************
								**** The following code is taken from sample available for given sensor****
								**************************************************************************/
								{
									//Measure T in Celsius
									int t_fine, adc_T;
									int var1, var2, T;
									short dig_T1, dig_T2, dig_T3;
									unsigned short us_Comp;
									short s_CompX;

									us_Comp = (unsigned short)ucRCPat[0x88] + ((unsigned short)ucRCPat[0x89] << 8);
									dig_T1 = (unsigned short)us_Comp;
									s_CompX = (short)ucRCPat[0x8a] + ((short)ucRCPat[0x8b] << 8);
									dig_T2 = s_CompX;
									s_CompX = (short)ucRCPat[0x8c] + ((short)ucRCPat[0x8d] << 8);
									dig_T3 = s_CompX;

									adc_T = (int)ucRCPat[0xff + 4] + ((int)ucRCPat[0xff + 3] << 8);
									adc_T = adc_T << 4;
									adc_T = adc_T | ((int)ucRCPat[0xff + 5] >> 4);
									var1 = ((((adc_T >> 3) - ((int)dig_T1 << 1)))*((int)dig_T2)) >> 11;
									var2 = (((((adc_T >> 4) - ((int)dig_T1))*((adc_T >> 4) - ((int)dig_T1))) >> 12)*((int)dig_T3)) >> 14;
									t_fine = var1 + var2;
									t_fine_mst = t_fine;
									T = (t_fine * 5 + 128) >> 8;
									df_T = 0.01 * (double)T;
								}

									{
										//pressure
										__int64 var1, var2, p;
										int adc_P;
										unsigned short dig_P1;
										short dig_P2, dig_P3, dig_P4, dig_P5, dig_P6, dig_P7, dig_P8, dig_P9;
										short s_CompX;
										unsigned short us_Comp;

										us_Comp = (unsigned short)ucRCPat[0x8e] + ((unsigned short)ucRCPat[0x8f] << 8);
										dig_P1 = (unsigned short)us_Comp;
										s_CompX = (short)ucRCPat[0x90] + ((short)ucRCPat[0x91] << 8);
										dig_P2 = s_CompX;
										s_CompX = (short)ucRCPat[0x92] + ((short)ucRCPat[0x93] << 8);
										dig_P3 = s_CompX;
										s_CompX = (short)ucRCPat[0x94] + ((short)ucRCPat[0x95] << 8);
										dig_P4 = s_CompX;
										s_CompX = (short)ucRCPat[0x96] + ((short)ucRCPat[0x97] << 8);
										dig_P5 = s_CompX;
										s_CompX = (short)ucRCPat[0x98] + ((short)ucRCPat[0x99] << 8);
										dig_P6 = s_CompX;
										s_CompX = (short)ucRCPat[0x9a] + ((short)ucRCPat[0x9b] << 8);
										dig_P7 = s_CompX;
										s_CompX = (short)ucRCPat[0x9c] + ((short)ucRCPat[0x9d] << 8);
										dig_P8 = s_CompX;
										s_CompX = (short)ucRCPat[0x9e] + ((short)ucRCPat[0x9f] << 8);
										dig_P9 = s_CompX;

										adc_P = (int)ucRCPat[0xff + 1] + ((int)ucRCPat[0xff] << 8);
										adc_P = adc_P << 4;
										adc_P = adc_P | ((int)ucRCPat[0xff + 2] >> 4);

										var1 = ((__int64)t_fine_mst) - 128000;
										var2 = var1 * var1 * (__int64)dig_P6;
										var2 = var2 + ((var1*(__int64)dig_P5) << 17);
										var2 = var2 + (((__int64)dig_P4) << 35);
										var1 = ((var1 * var1 * (__int64)dig_P3) >> 8) + ((var1 * (__int64)dig_P2) << 12);
										var1 = (((((__int64)1) << 47) + var1))*((__int64)dig_P1) >> 33;
										if (var1 == 0)
										{
											var1 = 1;
											//avoid exception caused by division by zero 
										}
										p = 1048576 - adc_P;
										p = (((p << 31) - var2) * 3125) / var1;
										var1 = (((__int64)dig_P9) * (p >> 13) * (p >> 13)) >> 25;
										var2 = (((__int64)dig_P8) * p) >> 19;
										p = ((p + var1 + var2) >> 8) + (((__int64)dig_P7) << 4);
										df_P = (double)p / (double)256;

										//AlexL found by testing
										df_P += 2925;
									}

									{
										//humidity
										int v_x1_u32r, adc_H;
										unsigned int ui_Res;

										unsigned char dig_H1, dig_H3;
										char dig_H6;
										short dig_H2, dig_H4, dig_H5;

										adc_H = (short)ucRCPat[0xff + 0x07] + ((short)ucRCPat[0xff + 0x06] << 8);

										dig_H1 = (unsigned char)ucRCPat[0xa1];
										dig_H2 = (short)ucRCPat[0xe1] + ((short)ucRCPat[0xe2] << 8);
										dig_H3 = (unsigned char)ucRCPat[0xe3];

										dig_H4 = (short)ucRCPat[0xe5] & 0x0f;
										dig_H4 += (short)ucRCPat[0xe4] << 4;

										dig_H5 = (short)(ucRCPat[0xe5] & 0xf0) >> 4;
										dig_H5 += (short)(ucRCPat[0xe6] << 8) >> 4;

										dig_H6 = (char)ucRCPat[0xe7];

										v_x1_u32r = (t_fine_mst - ((int)76800));
										v_x1_u32r = (((((adc_H << 14) - (((int)dig_H4) << 20) - (((int)dig_H5) * v_x1_u32r)) + ((int)16384)) >> 15) * (((((((v_x1_u32r * ((int)dig_H6)) >> 10) * (((v_x1_u32r * ((int)dig_H3)) >> 11) + ((int)32768))) >> 10) + ((int)2097152)) * ((int)dig_H2) + 8192) >> 14));
										v_x1_u32r = (v_x1_u32r - (((((v_x1_u32r >> 15) * (v_x1_u32r >> 15)) >> 7) * ((int)dig_H1)) >> 4));
										v_x1_u32r = (v_x1_u32r < 0 ? 0 : v_x1_u32r); v_x1_u32r = (v_x1_u32r > 419430400 ? 419430400 : v_x1_u32r);
										ui_Res = (unsigned int)(v_x1_u32r >> 12);
										df_H = (double)ui_Res / (double)1024;
									}

									ttTime = time(NULL);
									ctime_s((char*)ucVdata, sizeof(ucVdata), &ttTime);
									for (uiRCCntr = 0; uiRCCntr < sizeof(ucVdata); uiRCCntr++)
									{
										if (CARRRET == ucVdata[uiRCCntr])
										{
											ucVdata[uiRCCntr] = 0;
										}
									}
									bNodata = FALSE;
									swprintf_s(pGBuf, L"[%S]Temp, deg C: %lf; Pres, Pa: %lf; Hum, pH: %lf \n", ucVdata, df_T, df_P, df_H);
									if (hAWnd)
									{
										HWND hEditCtrl = GetDlgItem(hAWnd, IDC_TEXT);
										SetWindowText(hEditCtrl, pGBuf);
									}


									/**************************************
									** Storing temperature into log file***
									***************************************/
									if (!fopen_s(&fpFile, "temperatute.log", "a"))
									{
										fprintf(fpFile, "[%s] %lf\n", ucVdata, df_T);
										fclose(fpFile);
									}
									/**************************************
									** Storing pressure into log file***
									***************************************/
									if (!fopen_s(&fpFile, "pressure.log", "a"))
									{
										fprintf(fpFile, "[%s] %lf\n", ucVdata, df_P);
										fclose(fpFile);
									}
									/**************************************
									** Storing humidity into log file***
									***************************************/
									if (!fopen_s(&fpFile, "humidity.log", "a"))
									{
										fprintf(fpFile, "[%s] %lf\n", ucVdata, df_H);
										fclose(fpFile);
									}
									/**************************************
									******* Storing all into CSV file******
									***************************************/
									if (!fopen_s(&fpFile, "meteodata.csv", "a"))
									{
										fprintf(fpFile, "[%s],%lf,%lf,%lf\n", ucVdata, df_T, df_P, df_H);
										fclose(fpFile);
									}
									/*****************************
									***** Sending all to web******
									******************************/
									
									sprintf_s(cBuf, sizeof(cBuf), "GET /weather/getwx.php?p=[%s], %lf, %lf, %lf", ucVdata, df_T, df_P, df_H);
									for (uiRCCntr = PASS_GET; uiRCCntr < sizeof(cBuf); uiRCCntr++)
									{
										if (CHAR_SP == cBuf[uiRCCntr])
										{
											cBuf[uiRCCntr] = CHAR_X;
										}
									}

									memset(get_http, ' ', sizeof(get_http));
									strcat_s(cBuf, sizeof(cBuf), " HTTP/1.1\r\nHost: ");
									strcpy_s(get_http, 256, cBuf);
									strcat_s(get_http, 256, "www.alxlabs.ca");
									strcat_s(get_http, 256, "\r\nConnection: close\r\n\r\n");

									WSAStartup(MAKEWORD(2, 2), &wsaData);
									Socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
									host = gethostbyname("www.alxlabs.ca");

									SockAddr.sin_port = htons(80);
									SockAddr.sin_family = AF_INET;
									SockAddr.sin_addr.s_addr = *((unsigned long*)host->h_addr);

									connect(Socket, (SOCKADDR*)(&SockAddr), sizeof(SockAddr));
									send(Socket, get_http, strlen(get_http), 0);
									closesocket(Socket);
									WSACleanup();
							}
						}
					}
					else
					{
						uiMatch = 0;
					}

				}
			}
		}
	}
}

void LoadStringSafe(UINT nStrID, LPTSTR szBuf, UINT nBufLen)
{
	UINT nLen = LoadString(g_hInstance, nStrID, szBuf, nBufLen);
	if (nLen >= nBufLen)
		nLen = nBufLen - 1;
	szBuf[nLen] = 0;
}

BOOL CALLBACK WeatherProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HWND hChild;
	HWND hEditCtrl;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		if (CPopupWndData::s_pThis)
		{
			CPopupWndData::s_pThis->m_hWnd = hWnd;

			if (g_hIcon)
			{
				SendMessage(hWnd, WM_SETICON, ICON_BIG, (LPARAM) g_hIcon);
				SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM) g_hIcon);
			}

			for (hChild = GetWindow(hWnd, GW_CHILD); hChild; hChild = GetWindow(hChild, GW_HWNDNEXT))
				CPopupWndData::s_pThis->m_dwControls++;

			if (CPopupWndData::s_pThis->m_pControls = new CWndSizeData[CPopupWndData::s_pThis->m_dwControls])
			{
				RECT stRect;
				GetClientRect(hWnd, &stRect);
				CPopupWndData::s_pThis->m_stInitialSize.cx = stRect.right;
				CPopupWndData::s_pThis->m_stInitialSize.cy = stRect.bottom;

				DWORD dwControl = 0;
				for (hChild = GetWindow(hWnd, GW_CHILD); hChild; hChild = GetWindow(hChild, GW_HWNDNEXT))
				{
					RECT* pRect = &CPopupWndData::s_pThis->m_pControls[dwControl].m_stRect;
					GetWindowRect(hChild, pRect);
					ScreenToClient(hWnd, (POINT*) pRect);
					ScreenToClient(hWnd, ((POINT*) pRect) + 1);

					CPopupWndData::s_pThis->m_pControls[dwControl].m_hWnd = hChild;

					switch (GetDlgCtrlID(hChild))
					{
						case IDC_TEXT:
							CPopupWndData::s_pThis->m_pControls[dwControl].m_nResizeFlags = 0;
							{
								hEditCtrl = GetDlgItem(hWnd, IDC_TEXT);
								SetWindowText(hEditCtrl, pGBuf);
								hAWnd = hWnd;
							}
						break;
						default:
							CPopupWndData::s_pThis->m_pControls[dwControl].m_nResizeFlags = 0;
						break;
					}

					if (dwControl++ >= CPopupWndData::s_pThis->m_dwControls)
					{
						break;
					}
				}

			} 
			else
			{
				CPopupWndData::s_pThis->m_dwControls = 0;
			}
		}
		return TRUE;

	case WM_CLOSE:
		EndDialog(hWnd, IDCANCEL);
		hAWnd = NULL;
		return TRUE;

	case WM_COMMAND:
		return 0;
		break;

	case WM_DESTROY:
		return 0;
		break;

	default:
		return 0;
		break;
	}
	return FALSE;
}

LRESULT CALLBACK MainAProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		{
			NOTIFYICONDATA stData;
			ZeroMemory(&stData, sizeof(stData));
			stData.cbSize = sizeof(stData);
			stData.hWnd = hWnd;
			stData.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
			stData.uCallbackMessage = WM_TRAY;
			stData.hIcon = g_hIcon = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_TRAYICON));
			LoadStringSafe(IDS_TIP, stData.szTip, _countof(stData.szTip));
			if (!Shell_NotifyIcon(NIM_ADD, &stData))
				return -1; // oops
		}
		return 0;

	case WM_DESTROY:
		{
			NOTIFYICONDATA stData;
			ZeroMemory(&stData, sizeof(stData));
			stData.cbSize = sizeof(stData);
			stData.hWnd = hWnd;
			Shell_NotifyIcon(NIM_DELETE, &stData);
			aCommThread.detach();
		}
		return 0;

	case WM_TRAY:
		switch (lParam)
		{
		case WM_LBUTTONDOWN:
			SendMessage(hWnd, WM_COMMAND, ID_SHOW, 0);
			break;

		case WM_RBUTTONDOWN:
			{
				HMENU hMenu = LoadMenu(g_hInstance, MAKEINTRESOURCE(IDR_POPUP));
				if (hMenu)
				{
					HMENU hSubMenu = GetSubMenu(hMenu, 0);
					if (hSubMenu)
					{
						POINT stPoint;
						GetCursorPos(&stPoint);

						TrackPopupMenu(hSubMenu, TPM_LEFTALIGN | TPM_BOTTOMALIGN | TPM_RIGHTBUTTON, stPoint.x, stPoint.y, 0, hWnd, NULL);
					}

					DestroyMenu(hMenu);
				}
			}
			break;
		}
		return 0;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case ID_SHOW:
			if (CPopupWndData::s_pThis)
				SetForegroundWindow(CPopupWndData::s_pThis->m_hWnd);
			else
			{
				CPopupWndData stData;
				ZeroMemory(&stData, sizeof(stData));
				CPopupWndData::s_pThis = &stData;
				
				DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_CONVERTER), NULL, WeatherProc);

				if (stData.m_pControls)
					delete[] stData.m_pControls;
				CPopupWndData::s_pThis = NULL;
			}
			return 0;

		case ID_QUIT:
			PostQuitMessage(0);
			return 0;
		}
		break;

	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int WINAPI WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	WNDCLASS stWC;
	HWND hHiddenWnd;
	ZeroMemory(&stWC, sizeof(stWC));
	stWC.lpszClassName = _T("Alex_weather");
	hHiddenWnd = FindWindow(stWC.lpszClassName, NULL);
	pGBuf[0] = 0;
	if (hHiddenWnd)
	{
		PostMessage(hHiddenWnd, WM_TRAY, 0, WM_LBUTTONDOWN);
	}
	else
	{
		stWC.hInstance = hInstance;
		stWC.lpfnWndProc = MainAProc;

		ATOM aClass = RegisterClass(&stWC);
		if (aClass)
		{
			g_hInstance = hInstance;
			if (hHiddenWnd = CreateWindow((LPCTSTR) aClass, _T(""), 0, 0, 0, 0, 0, NULL, NULL, hInstance, NULL))
			{
				MSG stMsg;
				while (GetMessage(&stMsg, NULL, 0, 0) > 0)
				{
					TranslateMessage(&stMsg);
					DispatchMessage(&stMsg);
				}

				if (IsWindow(hHiddenWnd))
					DestroyWindow(hHiddenWnd);
			}
			UnregisterClass((LPCTSTR) aClass, g_hInstance);
		}
	}
	return 0;
}



